;------PORTOUT OPERATION---------------------------
.macro	ON_POUT
		sbi portd,@0
.endmacro

.macro	OFF_POUT
		cbi portd,@0
.endmacro
;--------------------------------------------

;--DELAY-----------------------------------------------------
.macro DELAY ;@0- in S
push xh
push xl
push yh
push yl
	ldi xh,HIGH(@0*1000)
	ldi xl,LOW(@0*1000)
YHcntStart:		ldi yh,HIGH(2000)
				ldi yl,LOW(2000)
YHcntCycle:	sbiw yl,1		;2cycle
			brne YHcntCycle ;2cycle 2+2=0.5 uS => 1000/0.5=2000
				sbiw xl,1
				brne YHcntStart
pop yl
pop yh
pop xl
pop xh
.endmacro
;--------------------------------------------------------------
;-----------------NOTA-----------------------------------------
.macro NOTA ;@0 T in uS of NOTA, @1- t of NOTA, @3 POUT number
push xh
push xl
push yh
push yl
l_tnota:		ldi yl, LOW(1000000/@0*@1) ;counter of cycles 
				ldi yh,HIGH(1000000/@0*@1)
l_T: ldi xl, LOW(@0)
	 ldi xh,HIGH(@0)
	 sbi portd,@2		;plus halfperiod
l_T1:	sbiw xl,1			;2cycle
		brne l_T1			;2cycle 2+2=0.5 uS
	 ldi xl, LOW(@0)
	 ldi xh,HIGH(@0)
	 cbi portd,@2		;minus halfperiod
l_T2:	sbiw xl,1			;2cycle
		brne l_T2			;2cycle 2+2=0.5 uS
				sbiw yl,1
				brne l_T
pop yl
pop yh
pop xl
pop xh
.endmacro
;-------------------------------------
;--------JUMP-------------------------
.macro	JUMP
		rjmp @0
.endmacro

.macro	JUMP_IF_YES_PIN
		sbic pinc,@0
		rjmp @1
.endmacro

.macro	JUMP_IF_NO_PIN
		sbis pinc,@0
		rjmp @1
.endmacro

.macro	JUMP_IF_ZERO
		brne exit
		rjmp @0
exit:
.endmacro

.macro	JUMP_IF_NO_ZERO
		breq exit
		rjmp @0
exit:
.endmacro
;-------------------------------------

;-----LOAD----------------------------
.macro LOAD
ldi @0l,LOW(@1)
ldi @0h,HIGH(@1)
.endmacro

.macro MOVE 
mov @0l,@1l
mov @0h,@1h
.endmacro

.macro COMPARE
cp @0l,@1l
cpc @0h,@1h
.endmacro 
;--------------------------------
;------Math-------------------
.macro DECREMENT
sbiw @0l,1
.endmacro

.macro INCREMENT
adiw @0l,1
.endmacro
;-----------------------------
